bl_info = {
    "name": "Distribute",
    "description": "Distribute objects along X, Y, Z axis",
    "author": "Luis Del Aguila",
    "version": (0, 0, 1),
    "blender": (2, 93, 0),
    "location": "View 3D > Sidebar > Edit Tab > Distribute (panel)",
    "warning": "",
    "doc_url": "https://bit.ly/3hrtndi",
    "category": "Mesh",
}

import bpy

from bpy.props import (StringProperty,
                       BoolProperty,
                       IntProperty,
                       FloatProperty,
                       FloatVectorProperty,
                       EnumProperty,
                       PointerProperty,
                       )
from bpy.types import (Panel,
                       Operator,
                       AddonPreferences,
                       PropertyGroup,
                       )
                       
                       
#============================================================================================
#            APLICACION DISTRIBUIR
#============================================================================================  

""" True es max """
""" False es min """
    
#objs = bpy.context.selected_objects
    
def Obtlocation(obj,eje):
    if eje=="x":
        return obj.location.x
    elif eje=="y":
        return obj.location.y
    elif eje=="z":
        return obj.location.z

def Ponlocation(obj,eje,pos):
    if eje=="x":
        obj.location.x=pos
    elif eje=="y":
        obj.location.y=pos
    elif eje=="z":
        obj.location.z=pos

def MinMaxVerGlobal(obj,eje,minmax):
    verts = [vert.co for vert in obj.data.vertices] 
    vertsEje=[]
    for vert in verts:
        v_local = vert
        v_global = obj.matrix_world @ v_local
        if eje=="x":
            vertsEje.append(v_global.x)                              
        elif eje=="y":
            vertsEje.append(v_global.y)
        elif eje=="z":   
            vertsEje.append(v_global.z)                              
    if minmax:
       return max(vertsEje)
    else:
       return min(vertsEje)

def OrdenarObjs(eje, objs):
    #objs = bpy.context.selected_objects
    if eje=="x":
        objs.sort(key = lambda o: o.location.x)    
    elif eje=="y":
        objs.sort(key = lambda o: o.location.y)    
    elif eje=="z":
        objs.sort(key = lambda o: o.location.z)    


def distribuirOrigen(eje):
    objs = bpy.context.selected_objects
    print("distribuyendo = ", eje)
    OrdenarObjs(eje,objs)           

    distanciaTotal=Obtlocation(objs[len(objs)-1],eje)-Obtlocation(objs[0],eje)
    posini=Obtlocation(objs[0],eje)
        
    if (len(objs)-1)>0:
        espacio=distanciaTotal/(len(objs)-1)    
    else:
        espacio=distanciaTotal            

    for obj in objs:
        Ponlocation(obj,eje,posini)
        posini=posini+espacio   
        
    
def distribuirMinMax(eje,minmax): 
    objs = bpy.context.selected_objects      
    vertices=[]
    nuevaposicion=list(range(len(objs)))
    
    OrdenarObjs(eje,objs)
        
    for obj in objs:
        if minmax:
            vertices.append(MinMaxVerGlobal(obj,eje,minmax))
        else:
            vertices.append(MinMaxVerGlobal(obj,eje,minmax))
            
    vertices.sort()    
    distanciaTotal=vertices[len(vertices)-1]-vertices[0]
    
    if (len(vertices)-1)>0:
        espacio=distanciaTotal/(len(vertices)-1)    
    else:
        espacio=distanciaTotal
     
    nuevaposicion[0]=Obtlocation(objs[0],eje)
    nuevaposicion[len(objs)-1]=Obtlocation(objs[len(objs)-1],eje)        
            
    for i in range(1,len(objs)-1):
        g1=vertices[i-1]-Obtlocation(objs[i-1],eje)
        g2=vertices[i]-Obtlocation(objs[i],eje)
        nuevaposicion[i]=nuevaposicion[i-1]+g1+(espacio-g2)        
            
    for j in range(1,len(objs)-1):
        Ponlocation(objs[j],eje,nuevaposicion[j])    

def distribuirEspacio(eje):
    objs = bpy.context.selected_objects
    nuevaposicion=list(range(len(objs))) 
    
    OrdenarObjs(eje,objs)  
          
    ocupado=0          
    for j in range(1,len(objs)-1):
            ocupado=ocupado+(MinMaxVerGlobal(objs[j],eje,True)-MinMaxVerGlobal(objs[j],eje,False))
            
    distanciaTotal=MinMaxVerGlobal(objs[len(objs)-1],eje,False)-MinMaxVerGlobal(objs[0],eje,True)
    espaciolibre=distanciaTotal-ocupado
    
    if (len(objs)-1)>0:
        espacio=espaciolibre/(len(objs)-1)    
    else:
        espacio=espaciolibre
 
    nuevaposicion[0]=Obtlocation(objs[0],eje)
    nuevaposicion[len(objs)-1]=Obtlocation(objs[len(objs)-1],eje)

    for i in range(1,len(objs)-1):
        g1=MinMaxVerGlobal(objs[i-1],eje,True)-Obtlocation(objs[i-1],eje)
        g2=Obtlocation(objs[i],eje)-MinMaxVerGlobal(objs[i],eje,False)
        nuevaposicion[i]=nuevaposicion[i-1]+g1+espacio+g2     
        
    for j in range(1,len(objs)-1):
        Ponlocation(objs[j],eje,nuevaposicion[j])    

def longitudobjs():
    objs = bpy.context.selected_objects
    return len(objs)

#============================================================================================
#            OPERATOR
#============================================================================================  

class C3000_OT_DisMax(bpy.types.Operator):
    #objs = bpy.context.selected_objects    
    bl_idname = "object.dismax"
    bl_label = "Distribute objects along X, Y, Z axis"
    bl_options = {'REGISTER', 'UNDO'}        
    def execute(self, context):
        mytool = context.scene.my_tool
        op=(mytool.my_toogle_X*4)+(mytool.my_toogle_Y*2)+mytool.my_toogle_Z    
        #if len(objs)>1:
        if longitudobjs()>1:
            if op==1:
                distribuirMinMax("z",True)
            elif op==2:    
                distribuirMinMax("y",True)
            elif op==3:    
                distribuirMinMax("y",True)
                distribuirMinMax("z",True)
            elif op==4:    
                distribuirMinMax("x",True)
            elif op==5:    
                distribuirMinMax("x",True)
                distribuirMinMax("z",True)
            elif op==6:    
                distribuirMinMax("x",True)
                distribuirMinMax("y",True)
            elif op==7:    
                distribuirMinMax("x",True)
                distribuirMinMax("y",True)
                distribuirMinMax("z",True)
                
        return {'FINISHED'}   

class C3000_OT_DisMin(bpy.types.Operator):
    #objs = bpy.context.selected_objects
    bl_idname = "object.dismin"
    bl_label = "Distribute objects along X, Y, Z axis"
    bl_options = {'REGISTER', 'UNDO'}        
    def execute(self, context):
        mytool = context.scene.my_tool
        op=(mytool.my_toogle_X*4)+(mytool.my_toogle_Y*2)+mytool.my_toogle_Z    
        #if len(objs)>1:
        if longitudobjs()>1:
            if op==1:
                distribuirMinMax("z",False)
            elif op==2:    
                distribuirMinMax("y",False)
            elif op==3:    
                distribuirMinMax("y",False)
                distribuirMinMax("z",False)
            elif op==4:    
                distribuirMinMax("x",False)
            elif op==5:    
                distribuirMinMax("x",False)
                distribuirMinMax("z",False)
            elif op==6:    
                distribuirMinMax("x",False)
                distribuirMinMax("y",False)
            elif op==7:    
                distribuirMinMax("x",False)
                distribuirMinMax("y",False)
                distribuirMinMax("z",False)
                
        return {'FINISHED'}   
   
        
class C3000_OT_DisEsp(bpy.types.Operator):
    #objs = bpy.context.selected_objects
    bl_idname = "object.disesp"
    bl_label = "Distribute objects along X, Y, Z axis"
    bl_options = {'REGISTER', 'UNDO'}        
    def execute(self, context):
        mytool = context.scene.my_tool
        op=(mytool.my_toogle_X*4)+(mytool.my_toogle_Y*2)+mytool.my_toogle_Z    
        #if len(objs)>1:
        if longitudobjs()>1:
            if op==1:
                distribuirEspacio("z")
            elif op==2:    
                distribuirEspacio("y")
            elif op==3:    
                distribuirEspacio("y")
                distribuirEspacio("z")
            elif op==4:    
                distribuirEspacio("x")
            elif op==5:    
                distribuirEspacio("x")
                distribuirEspacio("z")
            elif op==6:    
                distribuirEspacio("x")
                distribuirEspacio("y")
            elif op==7:    
                distribuirEspacio("x")
                distribuirEspacio("y")
                distribuirEspacio("z")
                
        return {'FINISHED'}
     
class C3000_OT_DisOrig(bpy.types.Operator):
    #objs = bpy.context.selected_objects
    bl_idname = "object.disorig"
    bl_label = "Distribute objects along X, Y, Z axis"
    bl_options = {'REGISTER', 'UNDO'}        
    
    def execute(self, context):
         mytool = context.scene.my_tool         
         op=(mytool.my_toogle_X*4)+(mytool.my_toogle_Y*2)+mytool.my_toogle_Z
         #if len(objs)>1:
         if longitudobjs()>1:
             if op==1:
                distribuirOrigen("z")
             elif op==2:    
                distribuirOrigen("y")
             elif op==3:    
                distribuirOrigen("y")
                distribuirOrigen("z")
             elif op==4:    
                distribuirOrigen("x")
             elif op==5:    
                distribuirOrigen("x")
                distribuirOrigen("z")
             elif op==6:    
                distribuirOrigen("x")
                distribuirOrigen("y")
             elif op==7:    
                distribuirOrigen("x")
                distribuirOrigen("y")
                distribuirOrigen("z")
                         
         return {'FINISHED'}
    
#============================================================================================
#            INTERFACE
#============================================================================================  
  
class C3000_ST_Set(PropertyGroup):
    
    my_axis : EnumProperty(
        items = [("x", "X", "", 1),
                 ("y", "Y", "", 2),
                 ("z", "Z", "", 3)],
        description="Axis used by the mirror modifier",
        )  
            
    my_toogle_X : BoolProperty(
        name="Enable or Disable",
        description="A bool property",
        default = True
        )      
        
    my_toogle_Y : BoolProperty(
        name="Enable or Disable",
        description="A bool property",
        default = True
        )              
        
    my_toogle_Z : BoolProperty(
        name="Enable or Disable",
        description="A bool property",
        default = True
        )                     

class C3000_PT_Dis(bpy.types.Panel):
    """Creates a Panel in the Object properties window"""
    bl_label = "Distribute objects"
    bl_idname = "C3000_PT_Dis"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "Edit"
        
    def draw(self, context):
        layout = self.layout
        scene = context.scene
        mytool = scene.my_tool

        obj = context.object

        #layout.prop(mytool, "my_axis", text = "Mirror Axis", expand=True) 
        row = layout.row()
        row.prop(mytool, "my_toogle_X", text="X", toggle=True)
        row.prop(mytool, "my_toogle_Y", text="Y", toggle=True)
        row.prop(mytool, "my_toogle_Z", text="Z", toggle=True)        
        
        row = layout.row()
        row.operator(C3000_OT_DisMin.bl_idname,text="|<") 
        row.operator(C3000_OT_DisOrig.bl_idname,text="<>") 
        row.operator(C3000_OT_DisMax.bl_idname,text=">|") 
        row.operator(C3000_OT_DisEsp.bl_idname,text="||")                 
  
#============================================================================================
#            REGISTRO
#============================================================================================    
 
cls=(
    C3000_OT_DisMin,
    C3000_OT_DisMax,
    C3000_OT_DisEsp,
    C3000_OT_DisOrig,
    C3000_PT_Dis,
    C3000_ST_Set
) 
    
def register():
    for c in cls:
        bpy.utils.register_class(c)        

    bpy.types.Scene.my_tool = PointerProperty(type=C3000_ST_Set)

def unregister():
    for c in cls:
        bpy.utils.unregister_class(c)  

    del bpy.types.Scene.my_tool

if __name__ == "__main__":
    register()    


